import java.awt.image.*;
import java.awt.color.*;
import java.io.*;
import javax.imageio.*;
import javax.swing.JFrame;


public class Convolve4 {
static final int wm = 21;
public static void getLine( BufferedImage img, int row, int dst[])
{
   int  v, r, g, b;
   int w1 = img.getWidth();
   //System.out.format("row %d%n",row);
   img.getRGB(0, row, w1, 1, dst, 0, w1);
   for (int i = 0; i < w1; i++) {
     v = dst[i];
     r = (v >> 16) & 0xFF;
     g = (v >> 8) & 0xFF;
     b = v & 0xFF;
     v = (r + g + b) / 3; // gray by averaging the pixels
     dst[i] = v;
   }
}
    public static int maxdiff(BufferedImage a, BufferedImage b) {
	int maxdiff = 0;
	int w = a.getWidth();
	int h = a.getHeight();	
	if (b.getWidth() != w || b.getHeight()!=h) {
	   System.out.println("Images not same size");
	   return -1;
	}
	int i, j, diff;
	int [] va = new int[w];
	int [] vb = new int[w];
	if (w<wm) System.out.format("%n%ndifference %n%n");
	for (j=0; j<h; j++) {
	   getLine(a,j,va);
	   getLine(b,j,vb);
	   for (i=0; i<w; i++) {
	      diff = va[i]-vb[i];
	      if (w<wm) System.out.format("%3d ",diff);
	      if (diff<0) diff = -diff;
	      if (diff>maxdiff) maxdiff = diff;
	   }
	   if (w<wm) System.out.format("%n");
	}
	System.out.format("max absolute difference: %d%n",maxdiff);
	return maxdiff;
    }
    public static void main(String [] args) {
	int display_mode = 1; // grayscale bipolar
	String filename = "test3.png";
	if (args.length>0) filename = args[0];
	if (args.length>1) display_mode = Integer.decode(args[1]);

	ImageFrame f1 = new ImageFrame(filename);
	f1.setLocation(10,10);
	f1.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	int w = f1.getWidth();
	int h = f1.getHeight();
        int wid = f1.img.getWidth();
	if (wid<wm) listImage.listGray(f1.img,filename);

        // use doConvolve (version1)

	//int mask[][] = { {-1, 0, 1},{-2, 0, 2},{-1, 0, 1} };
	int mask[][] = { {-1, -2, -1},{ 0, 0, 0},{ 1, 2, 1} };
	Convolve c = new Convolve(mask);
	c.setScale(8);
	c.setDisplayMode(display_mode);
	c.showMatrix(mask,"convolution mask");
	BufferedImage out1 = c.doConvolve(f1.img);
	ImageFrame f2 = new ImageFrame(out1,"version1");
	f2.setLocation(20+w,10);
	if (wid<wm) listImage.listGray(f2.img,"version1");

        // use doEdgeMag  (version2)

	c.edge_mode = 2; // show edge_y (grayscale display)
	BufferedImage out2 = c.doEdgeMag(f1.img);
	ImageFrame f3 = new ImageFrame(out2,"version2");
	f3.setLocation(10,20+h);
	if (wid<wm) listImage.listGray(out2,"version2");
	if (display_mode==1) maxdiff(f2.img,f3.img);

	c.edge_mode = 0; // show edge magnitude
	BufferedImage out3 = c.doEdgeMag(f1.img);
	ImageFrame f4 = new ImageFrame(out3,"edge magnitude");
	f4.setLocation(20+w,20+h);
		
    }
}
